#ifndef DRIVER_H
#define DRIVER_H

#include <gtk/gtk.h>

typedef struct driver_s {
     void (*init)();
     int (*start)();
     int (*stop)();
     int (*getrate)();
     int (*getperiodsize)();
     GtkWidget *(*getwidget)();
     const char *(*getname)();
} driver_t;

/* points to the driver currently in use */
extern driver_t *DRIVER;

/* an array of all available drivers */
extern driver_t *driver[];

void prepare_drivers();

#endif
